<template>
   <div id="app" class="container">
    <div class="page-header">
    </div>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title">Adicionar Produto</h3>
      </div>
      <div class="panel-body">
         <b-form id="form" class="form-inline" v-on:submit.prevent="addProduct">
          <div class="form-group">
            <label for="productName">Nome:</label>
            <input type="text" id="productName" class="form-control" v-model="newProduct.name">
          </div>
          <div class="form-group">
            <label for="productPrice">Preço:</label>
            <input type="text" id="productPrice" class="form-control" v-model="newProduct.price">
          </div>
          <input type="submit" class="btn btn-primary" value="Adicionar">
        </b-form>
      </div>
    </div>
    <br>
    <br>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title">Lista de produtos</h3>
      </div>
      <div class="panel-body">
        <table class="table table-striped">
          <thead>
            <tr>
              <th>Nome</th>
              <th>Preço</th>
              <th>Ações</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="product in products" :key="product.id">
              <td>{{product.name}}</td>
              <td>{{product.price}}</td>
              <td>
                <router-link :to="{ name: 'EditProduct', params: {id: product['.key']} }" class="btn btn-warning">
                  Editar
                </router-link>
                <span class="btn btn-primary" v-on:click="removeProduct(product)">Remover</span>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import toastr from "toastr";
import { db } from "../../config/db";

let productsRef = db.ref("products");

export default {
  name: "App",
  firebase: {
    products: productsRef
  },
  data() {
    return {
      newProduct: {
        name: "",
        price: ""
      }
    };
  },
  methods: {
    addProduct: function() {
      productsRef.push(this.newProduct);
      this.newProduct.name = "";
      this.newProduct.price = "";
    },
    removeProduct: function(product) {
      productsRef.child(product[".key"]).remove();
      toastr.success("Produto removido com sucesso");
    }
  }
};
</script>
<style>
#app {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
</style>
